%per_dsp_gen_exampP
N=512;
type=input('type=0--B-sp;1--dual to B-sp;2--fundamental sp;3 -- self-dual sp; ?')
figure
P=4;
subplot(2,2,1)
M=[];m=[];
[sp fsp]=D_gen_cons(N,1,P,type);
a=circ_h(sp,N/2);
M=[M;max(a)];m=[m;min(a)];
plot(a,'Linewidth',2);
title(['\fontsize{16}Order: '  int2str(P)])

hold on
[sp fsp]=D_gen_cons(N,2,P,type);
a=circ_h(sp,N/2);
plot(a,'--','Linewidth',2);
M=[M;max(a)];m=[m;min(a)];
hold on
[sp fsp]=D_gen_cons(N,3,P,type);
a=circ_h(sp,N/2);
plot(a,'.','Linewidth',2);
M=[M;max(a)];m=[m;min(a)];
Ma=max(M);ma=min(m);
axis([N/4 3*N/4 1.1*ma 1.1*Ma])
%axis([0 N -2 2])
hold off
set(gca,'XTick',[64  128 192])
set(gca,'XTickLabel',{'-64','0','64'})
set(gca,'FontSize',20)
M=[];m=[];
subplot(2,2,2)
[sp fsp]=D_gen_cons(N,1,P,type);
a=circ_h(fsp,N/2);
plot(a,'Linewidth',2);
title(['\fontsize{16}Order: '  int2str(P)])
M=[M;max(a)];m=[m;min(a)];
hold on
[sp fsp]=D_gen_cons(N,2,P,type);
a=circ_h(fsp,N/2);
plot(a,'--','Linewidth',2);
M=[M;max(a)];m=[m;min(a)];
hold on
[sp fsp]=D_gen_cons(N,3,P,type);
a=circ_h(fsp,N/2);
plot(a,'.','Linewidth',2)
M=[M;max(a)];m=[m;min(a)];
Ma=max(M);ma=min(m);
 axis([1,N 0 1.1*Ma])
hold off
set(gca,'XTick',[1 64 128 192 256])
set(gca,'XTickLabel',{'-128','-64','0','64','128'})
set(gca,'FontSize',20)
M=[];m=[];
P=10;
subplot(2,2,3)

[sp, fsp]=D_gen_cons(N,1,P,type);
a=circ_h(sp,N/2);
M=[M;max(a)];m=[m;min(a)];
plot(a,'Linewidth',2);
title(['\fontsize{16}Order: '  int2str(P)])
%axis([1 N -10 10])
hold on
[sp, fsp]=D_gen_cons(N,2,P,type);
a=circ_h(sp,N/2);
plot(a,'--','Linewidth',2);
%axis([0 N 0 2])
hold on
[sp fsp]=D_gen_cons(N,3,P,type);
a=circ_h(sp,N/2);
M=[M;max(a)];m=[m;min(a)];
plot(a,'.','Linewidth',3);
M=[M;max(a)];m=[m;min(a)];
Ma=max(M);ma=min(m);
axis([N/4 3*N/4 1.1*ma 1.1*Ma])
hold off
set(gca,'XTick',[1 64 128 192 256])
set(gca,'XTickLabel',{'-128','-64','0','64','128'})
set(gca,'FontSize',20)

M=[];m=[];
subplot(2,2,4)
[sp fsp]=D_gen_cons(N,1,P,type);
a=circ_h(fsp,N/2);
M=[M;max(a)];m=[m;min(a)];
plot(a,'Linewidth',2);
title(['\fontsize{16}Order: '  int2str(P)])

hold on
[sp fsp]=D_gen_cons(N,2,P,type);
a=circ_h(fsp,N/2);
M=[M;max(a)];m=[m;min(a)];
plot(a,'--','Linewidth',2);
hold on
[sp fsp]=D_gen_cons(N,3,P,type);
a=circ_h(fsp,N/2);
plot(a,'.','Linewidth',2)
Ma=max(a);
M=[M;max(a)];m=[m;min(a)];
Ma=max(M);ma=min(m);
 axis([1,N 0 1.1*Ma])
hold off
set(gca,'XTick',[1 64 128 192 256])
set(gca,'XTickLabel',{'-128','-64','0','64','128'})
%TicksLabelFont = ["Symbol", 20]
set(gca,'FontSize',20)